#include <CapacitiveSensor.h>
#include <avr/sleep.h>    //this AVR library contains the methods that controls the sleep modes
#define interruptPin 2    //Pin we are going to use to wake up the Arduino

  CapacitiveSensor   cs_4_2 = CapacitiveSensor(4,9);        // 10M (or so) resistor between pins 4 & 9, pin 9 is sensor pin, add a wire and or foil if desired

  void set_CS_Timeout_Millis(unsigned long timeout_millis = 100);  
  
  unsigned long interval=25;                                // the time we need to wait
  unsigned long previousMillis=0;                           // millis() returns an unsigned long.
  unsigned long csSum;                                      // für CSread()
  
  int LED_HB = 3;                                           // PWM heartbeat led 
  int Errors=4;                                             // Errors until losing the game
  int i=0;
  int counter = 0;
  
  const int buzzerPin = 5;                                  // pin connected to the buzzer    
 
  uint8_t hbval=128;                                        // Heartbeat standart rate
  int8_t hbdelta=8;                                         // Heartbeat interpolation
        
  const int c = 261;                                        // notes for the winning tune
  const int d = 294;
  const int e = 329;
  const int f = 349;
  const int g = 391;
  const int gS = 415;
  const int a = 440;
  const int aS = 455;
  const int b = 466;
  const int cH = 523;
  const int cSH = 554;
  const int dH = 587;
  const int dSH = 622;
  const int eH = 659;
  const int fH = 698;
  const int fSH = 740;
  const int gH = 784;
  const int gSH = 830;
  const int aH = 880;


void setup()                    
{
     cs_4_2.set_CS_AutocaL_Millis(0xFFFFFFFF);    // turn off autocalibrate on channel 1 - maybe turn it on - works like this for me
     Serial.begin(9600);
     pinMode(LED_HB, OUTPUT);                     // 3
     
     pinMode(LED_BUILTIN,OUTPUT);                 // 13 We use the led on pin 13 to indecate when Arduino is A sleep
     pinMode(interruptPin,INPUT_PULLUP);          // 2 Set pin d2 to input using the buildin pullup resistor
     digitalWrite(LED_BUILTIN,HIGH);              // turning LED on
     pinMode(buzzerPin, OUTPUT);                  // 5
     pinMode(12,INPUT_PULLUP);          
}


void loop()                    
{  
    
    cs_4_2.reset_CS_AutoCal();                //Stops readings

    Serial.println("begin    ");              // Serial output is good for caibration, but doesn't matter for the game
    delay(1000 );                             
      Errors=0;                  
    
    while (digitalRead(12)==HIGH){            //Twezzer pin
      
    CSread();                                 // Capacitve sensing method
    heartbeat();                              // Heartbeat method
    
    if (Errors >= 4 ){                        //Game lost 
      analogWrite(LED_HB, 255);
      Serial.print("Lost    ");
      tone(buzzerPin, 1000, 1000);  
      Serial.println("Restart.....");   
      delay(1005 ); 
      analogWrite(LED_HB, 0);
      Going_To_Sleep();
      //asm volatile ("  jmp 0");                   
    }
  }
      
      if (Errors < 4){
      song();
      Serial.println("Won");
      Serial.println("Won");
      Serial.println("Won"); 
      delay(10);
      }           
      Going_To_Sleep();              
      interval=25;
    delay(10);                              // arbitrary delay to limit data to serial port mindestens 100 samples per second is das vielleicht zu wening
}


void CSread() {

    long cs = cs_4_2.capacitiveSensor(80);  //a: Sensor resolution is set to 80
      if (cs > 100) {                       //b: Arbitrary number
        Serial.println(cs);
        csSum += cs;
        Serial.println(cs); 
          if (csSum >= 300)                 //c: This value is the threshold, a High value means it takes longer to trigger
          {
          Serial.print("Trigger: ");
          Errors++;
          interval-= 7;
          //Serial.print(Errors);
          Serial.print(" ");
          Serial.println(csSum);
          tone(buzzerPin, 1000, 300);      // Beep for a error
          delay(300);
          if (csSum > 0) { csSum = 0; }    //Reset
    }
  } 
  else {
    csSum = 0; //Timeout caused by bad readings
    
  }
}


void heartbeat() {


  
  unsigned long currentMillis = millis();                                        // grab current time
  
      // check if "interval" time has passed 
      if ((unsigned long)(currentMillis - previousMillis) >= interval) {         //checks if it should do something 
                                                                                 // this is the multitasking bit    
       if (hbval > 128)                                                          // It only does anything in IF condition every few miili seconds
        {                                                                        // so it can do the capacitive sensing in the mean time
          hbdelta = -hbdelta; 
          tone(buzzerPin, 500, 10);
          i++;
          if (interval < 25 &&  i > 10)  {interval++; i=0;}                                     
        }
        if (hbval < 32) hbdelta = -hbdelta;
       hbval += hbdelta;                                       
       analogWrite(LED_HB, hbval);        

        // save the "current" time
       previousMillis = millis();
  }
}

void Going_To_Sleep(){
    analogWrite(LED_HB, 0);
    digitalWrite(LED_BUILTIN,LOW);              
    sleep_enable();//Enabling sleep mode
    attachInterrupt(0, wakeUp, HIGH);//attaching a interrupt to pin d2
    set_sleep_mode(SLEEP_MODE_PWR_DOWN);//Setting the sleep mode, in our case full sleep
    digitalWrite(LED_BUILTIN,HIGH);//turning LED off
    //delay(1000); //wait a second to allow the led to be turned off before going to sleep
    sleep_cpu();//activating sleep mode
    Serial.println("just woke up!");//next line of code executed after the interrupt 
    digitalWrite(LED_BUILTIN,HIGH);//turning LED on
    detachInterrupt(0); //Removes the interrupt from pin 2;
  }

void wakeUp(){
  Serial.println("Wake up");               //Print message to serial monitor
   sleep_disable();                                 //Disable sleep mode
  
  Serial.println("bla");                            //Print message to serial monitor
}


void song()
{
 
  //Play first section
  firstSection();
 

}
 
void beep(int note, int duration)
{
  //Play tone on buzzerPin
  tone(buzzerPin, note, duration);
 
  //Play different LED depending on value of 'counter'
  if(counter % 2 == 0)
  {
    
    delay(duration);
    
  }else
  {
    
    delay(duration);
    
  }
 
  //Stop tone on buzzerPin
  noTone(buzzerPin);
 
  delay(50);
 
  //Increment counter
  counter++;
}
 
void firstSection()
{
  beep(a, 500);
  beep(a, 500);    
  beep(a, 500);
  beep(f, 350);
  beep(cH, 150);  
  beep(a, 500);
  beep(f, 350);
  beep(cH, 150);
  beep(a, 650);
 
  delay(500);
 
  beep(eH, 500);
  beep(eH, 500);
  beep(eH, 500);  
  beep(fH, 350);
  beep(cH, 150);
  beep(gS, 500);
  beep(f, 350);
  beep(cH, 150);
  beep(a, 650);
 
  delay(500);
}
 
void secondSection()
{
  beep(aH, 500);
  beep(a, 300);
  beep(a, 150);
  beep(aH, 500);
  beep(gSH, 325);
  beep(gH, 175);
  beep(fSH, 125);
  beep(fH, 125);    
  beep(fSH, 250);
 
  delay(325);
 
  beep(aS, 250);
  beep(dSH, 500);
  beep(dH, 325);  
  beep(cSH, 175);  
  beep(cH, 125);  
  beep(b, 125);  
  beep(cH, 250);  
 
  delay(350);
}
